<?php
/*************************************************************************************
 *                           usercp_thanks.php
 *************************************************************************************/
/* Settings */

// IDs of forums you don't want to show at the recent list
// Zero ('0') if no such forums. If multiply forums write as the following: '2,6'
$thanks_ignore = '0';

if (!defined('IN_PHPBB'))
{
     die('Hacking attempt');
}

include($phpbb_root_path . 'includes/functions_thanks.' . $phpEx);
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);

$page_title = $lang['thanks_page'];

// Input variables

     $mode = input_var('mode', array('thanked', 'thanks'), $lang['No_post_mode']);
     $user_id = input_var(POST_USERS_URL, 0, $lang['No_user']);

switch ($mode)
{
     case 'thanked':
          $thanks_sql = "p.poster_id = $user_id";
          $block_type = 'thanked';
          break;
     case 'thanks':
          $thanks_sql = "th.user_id = $user_id";
          $block_type = 'thanks';
          break;
}


$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;
$start = ($start < 0) ? 0 : $start;    


//
// Count Thanks
//
$result = db_query('SELECT p.post_id
                    FROM   ' . POSTS_TABLE . ' AS p
                    ,	   ' . THANKS_TABLE . ' AS th				
                    WHERE  '.$thanks_sql.'
                    AND    th.post_id = p.post_id
                    ORDER  by p.post_id'
				  );

$total_thank = $db->sql_numrows($result);


if ($mode=='thanked')
{
     $thanksrow = array();
     if ($row = $db->sql_fetchrow($result))
     {
          do { $thanksrow[] = $row['post_id']; }
          while ($row = $db->sql_fetchrow($result));
          $db->sql_freeresult($result);
     }
     for($i = 0; $i != count($thanksrow); $i++) 
	 {  if ($thanksrow[$i] != $thanksrow[$i+1]) 
	    {
	       $k=$k+1;
	    } 
	 }
}



//
// Load page header
//
include($phpbb_root_path . 'includes/page_header.' . $phpEx);

//
// Set filenames
//
$template->set_filenames(array('body' => 'profile_view_thanks.tpl'));

$template->assign_block_vars($block_type, array());


     $result = db_query("SELECT user_id, username, user_level FROM ". USERS_TABLE ." WHERE user_id = $user_id");
     if (!($user = $db->sql_fetchrow($result)))
     {
          message_die(GENERAL_ERROR, $lang['no_user']);
     }


     $temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$user_id");
     $user_profile_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_profile'] . '" alt="' . $lang['Read_profile'] . '" title="' . $lang['Read_profile'] . '" border="0" /></a>';
     $user_profile = '<a href="' . $temp_url . '">' . $lang['Read_profile'] . '</a>';
     $user_link = '<a href="' . $temp_url . '">' . $user['username'] . '</a>';

     //
     // Block title and number of reviews
     //
     switch ($mode)
     {

          case 'thanked':
               if (!$total_thank)
               {
                    message_die(GENERAL_MESSAGE, $lang['no_thanked'] . '<br /><br />' . sprintf($lang['view_profile'], '<a href="' . $temp_url . '">', '</a>'));
               }
               $num_reviews = $total_thank;
               $block_title = sprintf($lang['thanks'], $user_link) . ': '.$k. ' ('.$lang['total_thanks'].$total_thank.')';
               break;
          case 'thanks':
               if (!$total_thank)
               {
                    message_die(GENERAL_MESSAGE, $lang['no_thanks'] . '<br /><br />' . sprintf($lang['view_profile'], '<a href="' . $temp_url . '">', '</a>'));
               }

               $num_reviews = $total_thank;
               $block_title = sprintf($lang['thanked'], $user_link) . ': '.$total_thank. ' ('.$lang['total_thanks'].$total_thank.')';
               break;

     }


$pagination = generate_pagination("profile.$phpEx?mode=$mode&amp;u=$user_id", $num_reviews, $board_config['posts_per_page'], $start);

$template->assign_vars(array(
     'L_DISPLAY_POSTS' => $lang['thanks_display'],
     'L_GO' => $lang['Go'],
     'L_BACK_TO_TOP' => $lang['Back_to_top'],

     'L_AUTHOR' => $lang['Author'],
     'L_REVIEW' => $lang['thanks_message'],
     'L_POST_REF' => $lang['thanks_message'],
     'L_POSTED' => $lang['Posted'],

     //'S_REVIEW_ORDER_ACTION' => append_sid("profile.$phpEx?mode=$mode&start=$start&$view_param"),
     //'S_SELECT_POST_ORDER' => $select_post_order,

     'U_VIEWPROFILE_IMG' => $user_profile_img,

     'BLOCK_TITLE' => $block_title,
     'PAGINATION' => $pagination,
));


// Getting forums auth settings

$unauthed_forums = array();

$sql = "SELECT forum_id, auth_view FROM " . FORUMS_TABLE;
$result = $db->sql_query($sql) or message_die(GENERAL_ERROR, "Could not query new topic information", "", __LINE__, __FILE__, $sql);

$is_auth_ary = auth(AUTH_ALL, AUTH_LIST_ALL, $userdata);

if ( $num_forums = count($is_auth_ary) )
{
	while ( list($forum_id, $auth_mod) = each($is_auth_ary) )
      {
      	$unauthed = false;
            if ( !$auth_mod['auth_view'] )
            {
          		$thanks_ignore .= ', ' . $forum_id;
            }
      }
}

// Display thanks list

$result = db_query("SELECT DISTINCT p.post_id
                    ,      p.post_time
				    ,      p.poster_id
				    ,      t.topic_title
				    ,      pt.post_text
				    ,      pt.bbcode_uid
				    ,      u.username
				    ,      u.user_avatar
				    ,      u.user_allowavatar
				    ,      u.user_avatar_type
					,      MAX(th.thanks_time) AS thanks_time
                    FROM   " . POSTS_TABLE . " AS p
				    ,      " . THANKS_TABLE . " AS th
				    ,      " . TOPICS_TABLE . " AS t
				    ,	   " . POSTS_TEXT_TABLE . " AS pt
				    ,	   " . USERS_TABLE . " AS u
				    WHERE  ".$thanks_sql."
                    AND     t.forum_id NOT IN (" . $thanks_ignore . ") 					
				    AND     th.post_id = p.post_id
                    AND     t.topic_id = th.topic_id
                    AND     pt.post_id = th.post_id
                    AND     u.user_id = p.poster_id
					GROUP BY th.post_id
					ORDER BY thanks_time DESC
					LIMIT $start, " . $board_config['posts_per_page']
                  );      


for ($i = true; $row = $db->sql_fetchrow($result); $i = !$i) // $i is a row color ticker
{

     //
     // Get images & urls
     //
     if ($row['post_id'] != NO_ID)
     {
          $post_reference = '<a href="' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . '=' . $row['post_id']) . '#' . $row['post_id'] . '"><img src="' . $images['icon_latest_reply'] . '" title="' . $lang['thanks_message'] . '" border="0" /></a>';
     }
     else
     {
          $post_reference = $lang['No'];
     }


     if ($userdata['session_logged_in'] && $row['date'] > $userdata['user_lastvisit'])
     {
          $mini_post_img = $images['icon_minipost_new'];
          $mini_post_alt = $l_unread;
     }
     else
     {
          $mini_post_img = $images['icon_minipost'];
          $mini_post_alt = $l_read;
     }

     //
     // Editing information
     //
     if ($row['edit_count'])
     {
          $l_edit_time_total = ($row['edit_count'] == 1) ? $lang['Edited_time_total'] : $lang['Edited_times_total'];
          $l_edited_by = '<br />' . sprintf($l_edit_time_total, $row['username'], create_date($board_config['default_dateformat'], $row['edit_time'], $board_config['board_timezone']), $row['edit_count']);
     }

     $row_color = $i ? $theme['td_color1'] : $theme['td_color2'];
     $row_class = $i ? $theme['td_class1'] : $theme['td_class2'];


     $message = prepare_display($row['post_text'], $row['bbcode_uid'], true, true);

     $poster_avatar = '';
     if ( $row['user_avatar_type'] && $poster_id != ANONYMOUS && $row['user_allowavatar'] )
     {
          switch( $row['user_avatar_type'] )
          {
               case USER_AVATAR_UPLOAD:
                    $poster_avatar = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $row['user_avatar'] . '" alt="" border="0" />' : '';
                    break;
               case USER_AVATAR_REMOTE:
                    $poster_avatar = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $row['user_avatar'] . '" alt="" border="0" />' : '';
                    break;
               case USER_AVATAR_GALLERY:
                    $poster_avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $row['user_avatar'] . '" alt="" border="0" />' : '';
                    break;
          }
     }
     $poster_rank = ($row['rank_title']) ? $row['rank_title'].'<br>':'';
     $poster_rank_image = ($row['rank_iamge']) ? $row['rank_iamge'].'<br>':'';

     $auther=$row['username'];
     $poster_id=$row['poster_id'];
     $post_date = create_date($board_config['default_dateformat'], $row['post_time'], $board_config['board_timezone']);

	$email_img = $email = $icq_status_img = $icq_img = $icq = '';

	$temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $poster_id);
	$profile_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_profile'] . '" alt="' . $lang['Read_profile'] . '" title="' . $lang['Read_profile'] . '" border="0" /></a>';
	$profile = '<a href="' . $temp_url . '" title="' . $lang['Read_profile'] . '">' . $lang['Profile'] . '</a>';

	$temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . '=' . $poster_id);
	$pm_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
	$pm = '<a href="' . $temp_url . '" title="' . $lang['Send_private_message'] . '">' . $lang['Private_Message'] . '</a>';

	if (!empty($userdata['user_viewemail']) || $is_mod)
	{
		$email_uri = $board_config['board_email_form'] ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $poster_id) : 'mailto:' . $userdata['user_email'];

		$email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
		$email = '<a href="' . $email_uri . '" title="' . $lang['Send_email'] . '">' . $lang['Email'] . '</a>';
	}

	$www_img = $userdata['user_website'] ? '<a href="' . $userdata['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '';
	$www = $userdata['user_website'] ? '<a href="' . $userdata['user_website'] . '" target="_userwww" title="' . $lang['Visit_website'] . '">WWW</a>' : '';

	if (!empty($userdata['user_icq']))
	{
		$icq_status_img = '<a href="http://wwp.icq.com/' . $userdata['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $userdata['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
		$icq_img = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $userdata['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
		$icq = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $userdata['user_icq'] . '">ICQ</a>';
	}

	$aim_img = $userdata['user_aim'] ? '<a href="aim:goim?screenname=' . $userdata['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '';
	$aim = $userdata['user_aim'] ? '<a href="aim:goim?screenname=' . $userdata['user_aim'] . '&amp;message=Hello+Are+you+there?">AIM</a>' : '';

	$temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $poster_id);
	$msn_img = $userdata['user_msnm'] ? '<a href="' . $temp_url . '"><img src="' . $images['icon_msnm'] . '" alt="' . $lang['MSNM'] . '" title="' . $lang['MSNM'] . '" border="0" /></a>' : '';
	$msn = $userdata['user_msnm'] ? '<a href="' . $temp_url . '">MSNM</a>' : '';

	$yim_img = $userdata['user_yim'] ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $userdata['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
	$yim = $userdata['user_yim'] ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $userdata['user_yim'] . '&amp;.src=pg">YIM</a>' : '';




     // Total post's thanks count
     $result2 = db_query("SELECT u.user_id, u.username
           FROM " . THANKS_TABLE . " th, " . USERS_TABLE . " u
           WHERE th.post_id = " . $row['post_id'] . "
           AND th.user_id = u.user_id");

     $total_thank = $db->sql_numrows($result2);

     $thanks_users = array();

     while($row = $db->sql_fetchrow($result2)) {

          // Make thanker profile link
               $thanker_profile = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $row['user_id']);   
               $thanks_users[] = $row['username'];
     }

     $thanks_users = sprintf($lang['thanks_users'], $total_thank) . ' ' . implode(', ', $thanks_users);
     $thanks_status = '<img src="' . $images['thanks'][min($total_thank, 4)] . '" border="0" align="right"/>';



     $template->assign_block_vars($block_type . '.rows', array(
          'L_MINI_POST_ALT' => $mini_post_alt,

          'U_MINI_POST' => $mini_post_url,
          'U_REVIEW_ID' => $row['id'],

          'MESSAGE' => $message,
          'AUTHER_NAME' => $auther,
          'AVATAR' => $poster_avatar,
          'REVIEW' => '',
          'ROW_COLOR' => '#' . $row_color,
          'ROW_CLASS' => $row_class,
          'POST_REF' => $post_reference,
          'POST_DATE' => $post_date,
       'THANKS_USERS' => $thanks_users,
       'THANKS_STATUS' => $thanks_status,


          'POSTER_RANK' => $poster_rank,
          'RANK_IMAGE' => $poster_rank_image,

		'PROFILE_IMG' => $profile_img,
		'PROFILE' => $profile,
		'SEARCH_IMG' => $search_img,
		'SEARCH' => $search,
		'PM_IMG' => $pm_img,
		'PM' => $pm,
		'EMAIL_IMG' => $email_img,
		'EMAIL' => $email,
		'WWW_IMG' => $www_img,
		'WWW' => $www,
		'ICQ_STATUS_IMG' => $icq_status_img,
		'ICQ_IMG' => $icq_img,
		'ICQ' => $icq,
		'AIM_IMG' => $aim_img,
		'AIM' => $aim,
		'MSN_IMG' => $msn_img,
		'MSN' => $msn,
		'YIM_IMG' => $yim_img,
		'YIM' => $yim,


     ));
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.' . $phpEx);

?>